From c35f82913f86e9ccc255010372776f27b458e16f Mon Sep 17 00:00:00 2001
From: Keerthy <j-keerthy@ti.com>
Date: Tue, 5 Oct 2021 19:45:06 +0530
Subject: [PATCH 1/2] arch/arm64/boot/dts/ti/k3-j7200: Optimize DT for early
 Linux

Optimize DT for early Linux

Signed-off-by: Keerthy <j-keerthy@ti.com>
---
 .../boot/dts/ti/k3-j7200-common-proc-board.dts | 13 +++++++++++++
 arch/arm64/boot/dts/ti/k3-j7200-main.dtsi      | 18 ++++++++++++++++++
 2 files changed, 31 insertions(+)

diff --git a/arch/arm64/boot/dts/ti/k3-j7200-common-proc-board.dts b/arch/arm64/boot/dts/ti/k3-j7200-common-proc-board.dts
index 07a352550..4a8bd53ed 100644
--- a/arch/arm64/boot/dts/ti/k3-j7200-common-proc-board.dts
+++ b/arch/arm64/boot/dts/ti/k3-j7200-common-proc-board.dts
@@ -18,6 +18,7 @@
 	};
 
 	cpsw5g_virt_mac: main_r5fss_cpsw5g_virt_mac0 {
+		status = "disabled";
 		compatible = "ti,j721e-cpsw-virt-mac";
 		dma-coherent;
 		ti,psil-base = <0x4a00>;
@@ -236,11 +237,13 @@
 };
 
 &mcu_cpsw {
+	status = "disabled";
 	pinctrl-names = "default";
 	pinctrl-0 = <&mcu_cpsw_pins_default &mcu_mdio_pins_default>;
 };
 
 &davinci_mdio {
+	status = "disabled";
 	bus_freq = <20000>;
 
 	phy0: ethernet-phy@0 {
@@ -251,6 +254,7 @@
 };
 
 &cpsw_port1 {
+	status = "disabled";
 	phy-mode = "rgmii-rxid";
 	phy-handle = <&phy0>;
 };
@@ -316,15 +320,18 @@
 };
 
 &serdes_ln_ctrl {
+	status = "disabled";
 	idle-states = <J7200_SERDES0_LANE0_PCIE1_LANE0>, <J7200_SERDES0_LANE1_PCIE1_LANE1>,
 		      <J7200_SERDES0_LANE2_QSGMII_LANE1>, <J7200_SERDES0_LANE3_IP4_UNUSED>;
 };
 
 &usb_serdes_mux {
+	status = "disabled";
 	idle-states = <1>; /* USB0 to SERDES lane 3 */
 };
 
 &usbss0 {
+	status = "disabled";
 	pinctrl-names = "default";
 	pinctrl-0 = <&main_usbss0_pins_default>;
 	ti,vbus-divider;
@@ -332,21 +339,25 @@
 };
 
 &usb0 {
+	status = "disabled";
 	dr_mode = "otg";
 	maximum-speed = "high-speed";
 };
 
 &tscadc0 {
+	status = "disabled";
 	adc {
 		ti,adc-channels = <0 1 2 3 4 5 6 7>;
 	};
 };
 
 &serdes_refclk {
+	status = "disabled";
 	clock-frequency = <100000000>;
 };
 
 &serdes0 {
+	status = "disabled";
 	serdes0_pcie_link: phy@0 {
 		reg = <0>;
 		cdns,num-lanes = <2>;
@@ -365,6 +376,7 @@
 };
 
 &pcie1_rc {
+	status = "disabled";
 	reset-gpios = <&exp1 2 GPIO_ACTIVE_HIGH>;
 	phys = <&serdes0_pcie_link>;
 	phy-names = "pcie-phy";
@@ -372,6 +384,7 @@
 };
 
 &pcie1_ep {
+	status = "disabled";
 	phys = <&serdes0_pcie_link>;
 	phy-names = "pcie-phy";
 	num-lanes = <2>;
diff --git a/arch/arm64/boot/dts/ti/k3-j7200-main.dtsi b/arch/arm64/boot/dts/ti/k3-j7200-main.dtsi
index 79749f250..1bcb3bb71 100644
--- a/arch/arm64/boot/dts/ti/k3-j7200-main.dtsi
+++ b/arch/arm64/boot/dts/ti/k3-j7200-main.dtsi
@@ -323,6 +323,7 @@
 	};
 
 	main_uart2: serial@2820000 {
+		status = "disabled";
 		compatible = "ti,j721e-uart", "ti,am654-uart";
 		reg = <0x00 0x02820000 0x00 0x100>;
 		reg-shift = <2>;
@@ -336,6 +337,7 @@
 	};
 
 	main_uart3: serial@2830000 {
+		status = "disabled";
 		compatible = "ti,j721e-uart", "ti,am654-uart";
 		reg = <0x00 0x02830000 0x00 0x100>;
 		reg-shift = <2>;
@@ -349,6 +351,7 @@
 	};
 
 	main_uart4: serial@2840000 {
+		status = "disabled";
 		compatible = "ti,j721e-uart", "ti,am654-uart";
 		reg = <0x00 0x02840000 0x00 0x100>;
 		reg-shift = <2>;
@@ -362,6 +365,7 @@
 	};
 
 	main_uart5: serial@2850000 {
+		status = "disabled";
 		compatible = "ti,j721e-uart", "ti,am654-uart";
 		reg = <0x00 0x02850000 0x00 0x100>;
 		reg-shift = <2>;
@@ -375,6 +379,7 @@
 	};
 
 	main_uart6: serial@2860000 {
+		status = "disabled";
 		compatible = "ti,j721e-uart", "ti,am654-uart";
 		reg = <0x00 0x02860000 0x00 0x100>;
 		reg-shift = <2>;
@@ -388,6 +393,7 @@
 	};
 
 	main_uart7: serial@2870000 {
+		status = "disabled";
 		compatible = "ti,j721e-uart", "ti,am654-uart";
 		reg = <0x00 0x02870000 0x00 0x100>;
 		reg-shift = <2>;
@@ -401,6 +407,7 @@
 	};
 
 	main_uart8: serial@2880000 {
+		status = "disabled";
 		compatible = "ti,j721e-uart", "ti,am654-uart";
 		reg = <0x00 0x02880000 0x00 0x100>;
 		reg-shift = <2>;
@@ -414,6 +421,7 @@
 	};
 
 	main_uart9: serial@2890000 {
+		status = "disabled";
 		compatible = "ti,j721e-uart", "ti,am654-uart";
 		reg = <0x00 0x02890000 0x00 0x100>;
 		reg-shift = <2>;
@@ -449,6 +457,7 @@
 	};
 
 	main_i2c2: i2c@2020000 {
+		status = "disabled";
 		compatible = "ti,j721e-i2c", "ti,omap4-i2c";
 		reg = <0x00 0x2020000 0x00 0x100>;
 		interrupts = <GIC_SPI 202 IRQ_TYPE_LEVEL_HIGH>;
@@ -460,6 +469,7 @@
 	};
 
 	main_i2c3: i2c@2030000 {
+		status = "disabled";
 		compatible = "ti,j721e-i2c", "ti,omap4-i2c";
 		reg = <0x00 0x2030000 0x00 0x100>;
 		interrupts = <GIC_SPI 203 IRQ_TYPE_LEVEL_HIGH>;
@@ -471,6 +481,7 @@
 	};
 
 	main_i2c4: i2c@2040000 {
+		status = "disabled";
 		compatible = "ti,j721e-i2c", "ti,omap4-i2c";
 		reg = <0x00 0x2040000 0x00 0x100>;
 		interrupts = <GIC_SPI 204 IRQ_TYPE_LEVEL_HIGH>;
@@ -482,6 +493,7 @@
 	};
 
 	main_i2c5: i2c@2050000 {
+		status = "disabled";
 		compatible = "ti,j721e-i2c", "ti,omap4-i2c";
 		reg = <0x00 0x2050000 0x00 0x100>;
 		interrupts = <GIC_SPI 205 IRQ_TYPE_LEVEL_HIGH>;
@@ -493,6 +505,7 @@
 	};
 
 	main_i2c6: i2c@2060000 {
+		status = "disabled";
 		compatible = "ti,j721e-i2c", "ti,omap4-i2c";
 		reg = <0x00 0x2060000 0x00 0x100>;
 		interrupts = <GIC_SPI 206 IRQ_TYPE_LEVEL_HIGH>;
@@ -569,6 +582,7 @@
 	};
 
 	serdes_wiz0: wiz@5060000 {
+		status = "disabled";
 		compatible = "ti,j721e-wiz-10g";
 		#address-cells = <1>;
 		#size-cells = <1>;
@@ -612,6 +626,7 @@
 		};
 
 		serdes0: serdes@5060000 {
+			status = "disabled";
 			compatible = "ti,j721e-serdes-10g";
 			reg = <0x05060000 0x00010000>;
 			reg-names = "torrent_phy";
@@ -625,6 +640,7 @@
 	};
 
 	pcie1_rc: pcie@2910000 {
+		status = "disabled";
 		compatible = "ti,j7200-pcie-host", "ti,j721e-pcie-host";
 		reg = <0x00 0x02910000 0x00 0x1000>,
 		      <0x00 0x02917000 0x00 0x400>,
@@ -667,6 +683,7 @@
 	};
 
 	pcie1_ep: pcie-ep@2910000 {
+		status = "disabled";
 		compatible = "ti,j7200-pcie-ep", "ti,j721e-pcie-ep";
 		reg = <0x00 0x02910000 0x00 0x1000>,
 		      <0x00 0x02917000 0x00 0x400>,
@@ -687,6 +704,7 @@
 	};
 
 	usbss0: cdns-usb@4104000 {
+		status = "disabled";
 		compatible = "ti,j721e-usb";
 		reg = <0x00 0x4104000 0x00 0x100>;
 		dma-coherent;
-- 
2.17.1