From 0a9387be13e108c4e839123b66636d890bf9c8b1 Mon Sep 17 00:00:00 2001
From: Ramprasad N <x0038811@ti.com>
Date: Wed, 4 Sep 2019 11:04:09 +0530
Subject: [PATCH 4/4] Reduce the filesystem aggressively (tailored for VISION
 SDK)

Signed-off-by: Ramprasad N <x0038811@ti.com>
---
 .../recipes-core/images/tisdk-rootfs-image.bb          | 14 --------------
 .../packagegroups/packagegroup-arago-base.bb           |  4 ----
 .../packagegroups/packagegroup-arago-console.bb        |  5 -----
 .../packagegroups/packagegroup-arago-gst.bb            |  4 ----
 .../packagegroups/packagegroup-arago-tisdk-graphics.bb | 18 ++++++++++++------
 .../packagegroup-arago-tisdk-multimedia.bb             |  6 ------
 6 files changed, 12 insertions(+), 39 deletions(-)

diff --git a/meta-arago-distro/recipes-core/images/tisdk-rootfs-image.bb b/meta-arago-distro/recipes-core/images/tisdk-rootfs-image.bb
index bb2515a..e7da270 100644
--- a/meta-arago-distro/recipes-core/images/tisdk-rootfs-image.bb
+++ b/meta-arago-distro/recipes-core/images/tisdk-rootfs-image.bb
@@ -5,23 +5,9 @@ require arago-image.inc
 IMAGE_INSTALL += "\
     packagegroup-arago-base \
     packagegroup-arago-console \
-    packagegroup-arago-base-tisdk \
-    packagegroup-arago-test \
-    packagegroup-arago-test-addons \
     ${@bb.utils.contains('MACHINE_FEATURES','gpu','packagegroup-arago-tisdk-graphics','',d)} \
     ${@bb.utils.contains('MACHINE_FEATURES','gpu','packagegroup-arago-tisdk-gtk','',d)} \
-    packagegroup-arago-tisdk-qte \
-    ${@bb.utils.contains('MACHINE_FEATURES','dsp','packagegroup-arago-tisdk-opencl','',d)} \
-    ${@bb.utils.contains('MACHINE_FEATURES','dsp','packagegroup-arago-tisdk-opencl-extra','',d)} \
-    packagegroup-arago-tisdk-connectivity \
-    packagegroup-arago-tisdk-crypto \
-    packagegroup-arago-tisdk-matrix \
-    packagegroup-arago-tisdk-matrix-extra \
     packagegroup-arago-tisdk-multimedia \
-    packagegroup-arago-tisdk-amsdk \
-    packagegroup-arago-tisdk-addons \
-    packagegroup-arago-tisdk-addons-extra \
-    packagegroup-arago-tisdk-hmi \
     "
 
 export IMAGE_BASENAME = "tisdk-rootfs-image"
diff --git a/meta-arago-distro/recipes-core/packagegroups/packagegroup-arago-base.bb b/meta-arago-distro/recipes-core/packagegroups/packagegroup-arago-base.bb
index 4094d90..a40ea1c 100644
--- a/meta-arago-distro/recipes-core/packagegroups/packagegroup-arago-base.bb
+++ b/meta-arago-distro/recipes-core/packagegroups/packagegroup-arago-base.bb
@@ -15,10 +15,7 @@ ARAGO_BASE = "\
     module-init-tools \
     mtd-utils \
     mtd-utils-ubifs \
-    curl \
     initscript-telnetd \
-    ethtool \
-    thermal-init \
     bash \
     udev-extraconf \
     "
@@ -26,7 +23,6 @@ ARAGO_BASE = "\
 # these require meta-openembedded/meta-oe layer
 ARAGO_EXTRA = "\
     devmem2 \
-    tcpdump \
     "
 
 # minimal set of packages - needed to boot
diff --git a/meta-arago-distro/recipes-core/packagegroups/packagegroup-arago-console.bb b/meta-arago-distro/recipes-core/packagegroups/packagegroup-arago-console.bb
index 9fe17b9..c5d8490 100644
--- a/meta-arago-distro/recipes-core/packagegroups/packagegroup-arago-console.bb
+++ b/meta-arago-distro/recipes-core/packagegroups/packagegroup-arago-console.bb
@@ -71,11 +71,6 @@ ARAGO_SDK_PREREQ = "\
 
 ARAGO_CONSOLE = "\
     ${@bb.utils.contains('MACHINE_FEATURES', 'alsa', '${ARAGO_ALSA_EXTRA}', '',d)} \
-    ${@bb.utils.contains('DISTRO_FEATURES', 'wayland', '', '${ARAGO_TSLIB}', d)} \
-    ${ARAGO_NCURSES} \
-    ${ARAGO_FSTOOLS} \
-    ${ARAGO_UTILS} \
-    ${ARAGO_SDK_PREREQ} \
     "
 
 RDEPENDS_${PN} = "\
diff --git a/meta-arago-distro/recipes-core/packagegroups/packagegroup-arago-gst.bb b/meta-arago-distro/recipes-core/packagegroups/packagegroup-arago-gst.bb
index b2f117f..3d31f6b 100644
--- a/meta-arago-distro/recipes-core/packagegroups/packagegroup-arago-gst.bb
+++ b/meta-arago-distro/recipes-core/packagegroups/packagegroup-arago-gst.bb
@@ -21,10 +21,6 @@ GSTREAMER_DSP = " \
     ${@bb.utils.contains('MACHINE_FEATURES', 'dsp', 'gstreamer1.0-plugins-dsp66', '', d)} \
 "
 
-GSTREAMER_DEPS_append_dra7xx = " \
-    gstreamer1.0-plugins-hevc \
-    ${GSTREAMER_DSP} \
-"
 
 GSTREAMER_DEPS_append_keystone = " \
     gstreamer1.0-plugins-hevc \
diff --git a/meta-arago-distro/recipes-core/packagegroups/packagegroup-arago-tisdk-graphics.bb b/meta-arago-distro/recipes-core/packagegroups/packagegroup-arago-tisdk-graphics.bb
index 02404bc..7964245 100644
--- a/meta-arago-distro/recipes-core/packagegroups/packagegroup-arago-tisdk-graphics.bb
+++ b/meta-arago-distro/recipes-core/packagegroups/packagegroup-arago-tisdk-graphics.bb
@@ -13,9 +13,6 @@ GRAPHICS_WAYLAND = "\
     wayland-ivi-extension \
 "
 
-GRAPHICS_WAYLAND_append_omap-a15 = "\
-    ${@bb.utils.contains('MACHINE_FEATURES','gpu','chromium-wayland','',d)} \
-"
 
 GRAPHICS_WAYLAND_append_k3 = "\
     ${@bb.utils.contains('MACHINE_FEATURES','gpu','chromium-wayland','',d)} \
@@ -26,6 +23,18 @@ GRAPHICS_RDEPENDS = "\
     ${PREFERRED_PROVIDER_virtual/egl} \
     ${@bb.utils.contains('MACHINE_FEATURES','gpu','${PREFERRED_PROVIDER_virtual/gpudriver}','',d)} \
     ${@bb.utils.contains('MACHINE_FEATURES','gpu','glmark2','',d)} \
+    ti-sgx-ddk-um-dev \
+    cmem-dev \
+    libdrm-dev \
+    strace \
+    gdb \
+    omapconf \
+    elfutils-dev \
+    e2fsprogs-mke2fs \
+    dropbear \
+    linux-libc-headers-dev \
+    libdrm-tests \
+    kmscube \
 "
 GRAPHICS_RDEPENDS_remove_j7-evm = "ti-sgx-ddk-km"
 
@@ -37,9 +46,6 @@ GRAPHICS_DISPLAY_UTILS_append_omap-a15  = "\
 "
 
 GRAPHICS_RDEPENDS_append_omap-a15 = "\
-    ti-gc320-tests \
-    ti-gc320-driver \
-    ti-gc320-libs  \
 "
 
 RDEPENDS_${PN} = "\
diff --git a/meta-arago-distro/recipes-core/packagegroups/packagegroup-arago-tisdk-multimedia.bb b/meta-arago-distro/recipes-core/packagegroups/packagegroup-arago-tisdk-multimedia.bb
index 6f6f1f7..7b88808 100644
--- a/meta-arago-distro/recipes-core/packagegroups/packagegroup-arago-tisdk-multimedia.bb
+++ b/meta-arago-distro/recipes-core/packagegroups/packagegroup-arago-tisdk-multimedia.bb
@@ -7,7 +7,6 @@ PACKAGE_ARCH = "${MACHINE_ARCH}"
 inherit packagegroup
 
 MULTIMEDIA = " \
-    amsdk-av-files \
 "
 
 MULTIMEDIA_omapl138 = ""
@@ -21,13 +20,9 @@ MULTIMEDIA_append_ti43x = " \
 "
 
 MULTIMEDIA_append_omap-a15 = " \
-    dual-camera-demo \
-    image-gallery \
 "
 
 MULTIMEDIA_append_dra7xx = " \
-    hevc-arm-decoder \
-    ${@bb.utils.contains('MACHINE_FEATURES', 'dsp', 'qt-opencv-opencl-opengl-multithreaded-dev', '', d)} \
 "
 
 MULTIMEDIA_append_omap5-evm = " \
@@ -55,7 +50,6 @@ ACCEL_FW_append_omap5-evm = " \
 
 ACCEL_FW_append_dra7xx-evm = " \
     ${@bb.utils.contains('MACHINE_FEATURES', 'mmip', 'ipumm-fw', '', d)} \
-    vis \
 "
 
 ACCEL_FW_append_dra7xx-hs-evm = " \
-- 
1.9.1